<?php
/**
 * @copyright	Copyright (C) 2013 - 2014 Meftools, Inc. All rights reserved.
 * @license		GNU General Public License version 2 or later; see LICENSE.txt
 */
defined( '_JEXEC' ) or die( 'Restricted access' );

if(!defined('DS')) define('DS', DIRECTORY_SEPARATOR);

jimport("joomla.plugin.plugin");

class MefFunctionHelper{

	private $FParams = array();
	private $FCounter;
	private $NumberOfAyatINSura = array(7,286,200,176,120,165,206,75,129,109,123,111,43,52,99,128,111,110,98,135,112,78,118,64,77,227,93,88,69,60,34,30,73,54,45,83,182,88,75,85,54,53,89,59,37,35,38,29,18,45,60,49,62,55,78,96,29,22,24,13,14,11,11,18,12,12,30,52,52,44,28,28,20,56,40,31,50,40,46,42,29,19,36,25,22,17,19,26,30,20,15,21,11,8,8,19,5,8,8,11,11,8,3,9,5,4,7,3,6,3,5,4,5,6);

	public function __construct(){

	}

	private function getError($var){

		switch ($var) {
			case '0':
				return 'PLG_CONTENT_MEFQURAN_EMPTY';
			break;
			
			case '1':
				return 'PLG_CONTENT_MEFQURAN_NOINTEGER';
			break;

			case '2':
				return 'PLG_CONTENT_MEFQURAN_NOSURA';
			break;

			case '3':
				return 'PLG_CONTENT_MEFQURAN_BISMILLAH';
			break;

			case '4':
				return 'PLG_CONTENT_MEFQURAN_BSEPERATOR';
			break;

			case '5':
				return 'PLG_CONTENT_MEFQURAN_ESEPERATOR';
			break;

			case '6':
				return 'PLG_CONTENT_MEFQURAN_CODING';
			break;

			case '7':
				return 'PLG_CONTENT_MEFQURAN_NOAYA';
			break;

		}
	}
	

	private function IsNotEmpty($var){

		if(isset($var) AND $var != ""){
			return true;
		}else{
			return false; 
		}
	}

	private function TrimSpace($var){

		return trim(hex2bin(str_replace('c2a0', '', bin2hex($var))));

	}

	private function IsInteger($var){

		$var = $this->TrimSpace($var);

		if(intval($var) > 0 AND is_numeric($var) AND is_int(intval($var))){
			return true;
		}else{
			return false; 
		}
	}

	private function IsSura($var){

		$var = $this->TrimSpace($var);

		if($var > 0 AND $var <= 114){
			return true;
		}else{
			return false; 
		}
	}

	private function IsFromAya($var, $sura){

		$var = $this->TrimSpace($var);

		//$NumberOfAyatINSura = array(7,286,200,176,120,165,206,75,129,109,123,111,43,52,99,128,111,110,98,135,112,78,118,64,77,227,93,88,69,60,34,30,73,54,45,83,182,88,75,85,54,53,89,59,37,35,38,29,18,45,60,49,62,55,78,96,29,22,24,13,14,11,11,18,12,12,30,52,52,44,28,28,20,56,40,31,50,40,46,42,29,19,36,25,22,17,19,26,30,20,15,21,11,8,8,19,5,8,8,11,11,8,3,9,5,4,7,3,6,3,5,4,5,6);
		
		if($var > 0 AND $var <= $this->NumberOfAyatINSura[$sura-1]){
			return true;
		}else{
			return false; 
		}
	}

	private function IsToAya($var, $sura, $aya){

		$var = $this->TrimSpace($var);

		//$NumberOfAyatINSura = array(7,286,200,176,120,165,206,75,129,109,123,111,43,52,99,128,111,110,98,135,112,78,118,64,77,227,93,88,69,60,34,30,73,54,45,83,182,88,75,85,54,53,89,59,37,35,38,29,18,45,60,49,62,55,78,96,29,22,24,13,14,11,11,18,12,12,30,52,52,44,28,28,20,56,40,31,50,40,46,42,29,19,36,25,22,17,19,26,30,20,15,21,11,8,8,19,5,8,8,11,11,8,3,9,5,4,7,3,6,3,5,4,5,6);
		
		if($var > $aya AND $var <= $this->NumberOfAyatINSura[$sura-1]){
			return true;
		}else{
			return false; 
		}
	}		

	private function setBoolean($var){

		$var = $this->TrimSpace($var);

		$var = str_replace('"', '', $var);
		$var = str_replace("'", '', $var);

		if($var === "1") return true;
		if(strtolower($var) === "true") return true;
		if($var === "0") return false;
		if(strtolower($var) === "false"){ return false;}


	}


	private function setFParams($data, $var){

		$vars = explode("=", str_replace('"', '', $data[$var]));

		if($var == 0 OR (count($vars) == 1 AND $var <= 2) ){
		
			if(!$this->IsNotEmpty($data[$var])){
				$this->FParams[$var][0] = false;
				$this->FParams[$var][1] = $this->getError(0);
			}else if(!$this->IsInteger($data[$var])){
				$this->FParams[$var][0] = false;
				$this->FParams[$var][1] = $this->getError(1); 
			}else{

				switch ($var) {
					case '0':
							if(!$this->IsSura($data[$var])){
								$this->FParams[$var][0] = false;
								$this->FParams[$var][1] = $this->getError(2); 
							}else{
								$this->FParams[$var][0] = true;
								$this->FParams[$var][1] = $this->TrimSpace($data[$var]);
							}
						break;
					case '1':
							if(!$this->IsFromAya($data[$var], $data[0])){
								$this->FParams[$var][0] = false;
								$this->FParams[$var][1] = $this->getError(7); 
							}else{
								$this->FParams[$var][0] = true;
								$this->FParams[$var][1] = $this->TrimSpace($data[$var]);
							}
						break;
					case '2':
							if(!$this->IsToAya($data[$var], $data[0], $data[1])){
								$this->FParams[$var][0] = false;
								$this->FParams[$var][1] = $this->getError(7); 
							}else{
								$this->FParams[$var][0] = true;
								$this->FParams[$var][1] = $this->TrimSpace($data[$var]);
							}
						break;
					
					default:
						$this->FParams[$var][0] = true;
						$this->FParams[$var][1] = $this->TrimSpace($data[$var]);
						break;
				}
			}

		}else if(count($vars) > 1 AND $var <= 2){

			if(strtolower(trim($vars[0])) == "bismillah"){
				$this->FParams['bismillah'][0] = true;
				$this->FParams['bismillah'][1] = $this->setBoolean($vars[1]);

				
			}else{
				$this->FParams['bismillah'][0] = false;
				$this->FParams['bismillah'][1] = $this->getError(6);
			}

		}else{
			
			switch ($var) {

				case '3':
					if($vars[0] == true){
						$this->FParams[$var][0] = true;
						$this->FParams[$var][1] = trim($data[$var]);
						if(strtolower($vars[0]) == "bismillah"){

							$this->FParams['bismillah'][0] = true;
							$this->FParams['bismillah'][1] = $this->setBoolean(trim($vars[1]));
							
						}else{
							$this->FParams['bismillah'][0] = false;
							$this->FParams['bismillah'][1] = $this->getError(6);
						}
					}else if(strtolower($vars[0]) == "bismillah"){

							    $this->FParams['bismillah'][0] = true;
							    $this->FParams['bismillah'][1] = $this->setBoolean(trim($vars[1]));
											
							}else{
								$this->FParams['bismillah'][0] = false;
								$this->FParams['bismillah'][1] = $this->getError(6);
							}
					break;
				
				case '4':
					if($vars[0] == true){
						$this->FParams[$var][0] = true;
						$this->FParams[$var][1] = trim($data[$var]);
					}else if(strtolower($vars[0]) == "bismillah"){
						$this->FParams[$var][0] = true;
						$this->FParams[$var][1] = trim($data[$var]);

					}else if(strtolower(trim($vars[0])) == "gseparator"){
						$this->FParams[$var][0] = true;
						$this->FParams[$var][1] = trim($data[$var]);
					}else{
						$this->FParams[$var][0] = false;
						$this->FParams[$var][1] = $this->getError(4);
					}
					break;

				case '5':
					if($vars[0] == true){
						$this->FParams[$var][0] = true;
						$this->FParams[$var][1] = trim($data[$var]);
					}else if(strtolower($vars[0]) == "bismillah"){
						$this->FParams[$var][0] = true;
						$this->FParams[$var][1] = trim($data[$var]);

					}else if(strtolower(trim($vars[0])) == "eseparator"){
						$this->FParams[$var][0] = true;
						$this->FParams[$var][1] = trim($data[$var]);
					}else{
						$this->FParams[$var][0] = false;
						$this->FParams[$var][1] = $this->getError(5);
					}
					break;
			}

		}
	}

	public function getFParams(){

		return $this->FParams;
	} 

	public function getFCounter(){

		return $this->FCounter;
	}


	public function setParams($params){

		$data = explode(",", $params);

		for($i=0; $i<count($data); $i++){ 
			$this->setFParams($data, $i);
			$this->FCounter = count($data);

		}
	}

}

class MefQuranHelper{

	private $Params;
	private $Sura;
	private $From;
	private $To;
	private $BQSeparator;
	private $EQSeparator;
	private $BYSeparator;
	private $EYSeparator;
	private $Font;
	private $Style;
	private $DataLink;
	private $XmlData;
	private $Bismillah;
	public $QuranOutput = "";

	public function __construct($params){

		$this->Params = $params;
		$this->BQSeparator = $this->Params->get('bqseperator');
		$this->EQSeparator = $this->Params->get('eqseperator');
		$this->BYSeparator = $this->Params->get('byseperator');
		$this->EYSeparator = $this->Params->get('eyseperator');

		$this->LoadQuran();
	}

	private function LoadQuran(){

		$this->XmlData = JFactory::getXML(JURI::base()."plugins/content/mefquran/data/".$this->Params->get('quranfile'));

	}

	public function getQuran($params, $count){

				switch ($count) {
					case '1':
						if($params[0][0]){
							
							$this->Sura = $params[0][1] - 1;
							$this->getBismillah();
							return $this->getFullSura();
							
						}else{
							return JText::_($params[0][1]);
						}
				
					break;

					case '2':

							if($params[0][0]){
								$this->Sura = $params[0][1] - 1;
								if(isset($params[1][0]) AND $params[1][0]) {
										$this->getBismillah();
										$this->From = $params[1][1] - 1;
										return $this->getFromAyaToEnd();
								}else if(isset($params['bismillah'][0]) AND $params['bismillah'][0]){
										$this->getBismillah($params['bismillah'][1]);
										return $this->getFullSura();
								}else{
									return JText::_('PLG_CONTENT_MEFQURAN_CODING');
								}
							}else{
								return JText::_($params[0][1]);
							}
					break;

					case '3':

						if(isset($params['bismillah'][0]) AND $params['bismillah'][0]){
										
									if($params[0][0]){
										$this->Sura = $params[0][1] - 1;
										$this->getBismillah($params['bismillah'][1]);
										if($params[1][0]){
											$this->From = $params[1][1] - 1;
											return $this->getFromAyaToEnd();
										}else{
											return JText::_($params[1][1]);
										}
										
									}else{
										return JText::_($params[0][1]);
									}
						}else{
							if($params[0][0]){
								$this->Sura = $params[0][1] - 1;
								if($params[1][0]){
									$this->From = $params[1][1] - 1;
									if($params[2][0]){
										$this->To = $params[2][1] - 1;
										$this->getBismillah();
										return $this->getFromAyaToAya();
									}else{
										return JText::_($params[2][1]);
									}
								}else{
									return JText::_($params[1][1]);
								}
										
							}else{
								return JText::_('PLG_CONTENT_MEFQURAN_CODING');
							}
						}
				
					break;					

					case '4':
						if(isset($params['bismillah'][0]) AND $params['bismillah'][0]){
									if($params[0][0]){
										$this->Sura = $params[0][1] - 1;
										$this->getBismillah($params['bismillah'][1]);
										if($params[1][0]){
											$this->From = $params[1][1] - 1;
											if($params[2][0]){
											   $this->To = $params[2][1] - 1;
											   return $this->getFromAyaToAya();
											}else{
												return JText::_($params[2][1]);
											}
										}else{
											return JText::_($params[1][1]);
										}
										
									}else{
										return JText::_($params[0][1]);
									}
						}else{
							return JText::_('PLG_CONTENT_MEFQURAN_CODING');
						}
				
					break;

					default:
						return JText::_('PLG_CONTENT_MEFQURAN_CODING');
					break;

		}

	}


	private function getBismillah($var=""){

		if($var === ""){ 
			$this->Bismillah = $this->Params->get('bismillah');
		}else{
			$this->Bismillah = $var;
		}
	}


	private function getFullSura(){

		$this->QuranOutput = "<span class=\"mefquran\" ><span class=\"qseperator\" >"  . $this->BQSeparator . "</span>";

		if($this->Bismillah AND $this->Sura > 0){
			$this->QuranOutput .= "<span class=\"bismillah\" >".$this->XmlData->sura[$this->Sura]->aya[0]['bismillah'] . "</span>&nbsp;";
		}

		foreach ($this->XmlData->sura[$this->Sura]->aya as $aya) {
		
			$this->QuranOutput .= "<span class=\"ayat\" >" . $aya['text'] . "</span>" . "<span class=\"ayatnum\" >" . $this->BYSeparator . $aya['index'] . $this->EYSeparator . "</span>";

		}

		return $this->QuranOutput . "<span class=\"qseperator\" > " . $this->EQSeparator . "</span></span>";

	}


	private function getFromAyaToEnd(){

		$this->QuranOutput = "<span class=\"mefquran\" ><span class=\"qseperator\" >"  . $this->BQSeparator . "</span>";

		if($this->Bismillah AND $this->Sura > 0){
			$this->QuranOutput .= "<span class=\"bismillah\" >".$this->XmlData->sura[$this->Sura]->aya[0]['bismillah'] . "</span>&nbsp;";
		}		

		$i = 0;
		
		foreach ($this->XmlData->sura[$this->Sura]->aya as $aya) {

			if( $i >= $this->From AND $this->From > 0){
				$this->QuranOutput .= "<span class=\"ayat\" >" . $aya['text'] . "</span>" . "<span class=\"ayatnum\" >" . $this->BYSeparator . $aya['index'] . $this->EYSeparator . "</span>";
			}
			$i++;
		}


		return $this->QuranOutput . "<span class=\"qseperator\" > " . $this->EQSeparator . "</span></span>";
	}

	private function getFromAyaToAya(){

		$this->QuranOutput = "<span class=\"mefquran\" ><span class=\"qseperator\" >"  . $this->BQSeparator . "</span>";

		if($this->Bismillah AND $this->Sura > 0){
			$this->QuranOutput .= "<span class=\"bismillah\" >".$this->XmlData->sura[$this->Sura]->aya[0]['bismillah'] . "</span>&nbsp;";
		}		
		
		$i = 0;
		
		foreach ($this->XmlData->sura[$this->Sura]->aya as $aya) {
			
			if( $i >= $this->From AND $i <= $this->To AND $this->From > 0 AND $this->To > 0){
				$this->QuranOutput .= "<span class=\"ayat\" >" . $aya['text'] . "</span>" . "<span class=\"ayatnum\" >" . $this->BYSeparator . $aya['index'] . $this->EYSeparator . "</span>";
			}
			$i++;
		}

		return $this->QuranOutput . "<span class=\"qseperator\" > " . $this->EQSeparator . "</span></span>";
		
	}


}

?>